SystemOrganization addCategory: #ConfigurationOfPeriscope!

Object subclass: #ConfigurationOfPeriscope
	instanceVariableNames: 'project'
	classVariableNames: 'LastVersionLoad'
	poolDictionaries: ''
	category: 'ConfigurationOfPeriscope'!

!ConfigurationOfPeriscope commentStamp: '<historical>' prior: 0!
A configuration for the periscope project.!

!ConfigurationOfPeriscope class methodsFor: 'development support' stamp: 'TorstenBergmann 11/14/2013 21:18'!
DevelopmentSupport

"See the methods in the 'development support' category on the class-side of MetacelloBaseConfiguration. Decide what development support methods you would like to use and copy them the the class-side of your configuration."
	<apiDocumentation>
! !

!ConfigurationOfPeriscope class methodsFor: 'private' stamp: 'TorstenBergmann 11/14/2013 21:18'!
baseConfigurationClassIfAbsent: aBlock

	^Smalltalk
		at: #MetacelloBaseConfiguration
		ifAbsent: [ 
			self ensureMetacelloBaseConfiguration.
			Smalltalk at: #MetacelloBaseConfiguration ifAbsent: aBlock ].
! !

!ConfigurationOfPeriscope class methodsFor: 'private' stamp: 'TorstenBergmann 11/14/2013 21:18'!
ensureMetacello

	(self baseConfigurationClassIfAbsent: []) ensureMetacello! !

!ConfigurationOfPeriscope class methodsFor: 'private' stamp: 'TorstenBergmann 11/14/2013 21:18'!
ensureMetacelloBaseConfiguration

	Smalltalk
		at: #MetacelloBaseConfiguration
		ifAbsent: [ 
			| repository version |
			repository := MCHttpRepository location: 'http://seaside.gemstone.com/ss/metacello' user: '' password: ''.
			repository
				versionReaderForFileNamed: 'Metacello-Base-DaleHenrichs.2.mcz'
				do: [ :reader | 
					version := reader version.
					version load.
					version workingCopy repositoryGroup addRepository: repository ] ]! !

!ConfigurationOfPeriscope class methodsFor: 'metacello tool support' stamp: 'TorstenBergmann 11/14/2013 21:18'!
isMetacelloConfig
	"Answer true and the Metacello tools will operate on you"
	
	^true! !

!ConfigurationOfPeriscope class methodsFor: 'loading' stamp: 'TorstenBergmann 11/14/2013 21:18'!
load
	"Load the #stable version defined for this platform. The #stable version is the version that is recommended to be used on this platform."

	"self load"

	<apiDocumentation>
	^(self project version: #stable) load! !

!ConfigurationOfPeriscope class methodsFor: 'loading' stamp: 'TorstenBergmann 11/14/2013 21:18'!
loadBleedingEdge
	"Load the latest versions of the mcz files defined for this project. It is not likely that the #bleedingEdge has been tested."

	"self loadBleedingEdge"

	<apiDocumentation>
	^(self project version: #bleedingEdge) load! !

!ConfigurationOfPeriscope class methodsFor: 'loading' stamp: 'TorstenBergmann 11/14/2013 21:18'!
loadDevelopment
	"Load the #development version defined for this platform. The #development version will change over time and is not expected to be stable."

	"self loadDevelopment"

	<apiDocumentation>
	^(self project version: #development) load! !

!ConfigurationOfPeriscope class methodsFor: 'accessing' stamp: 'TorstenBergmann 11/14/2013 21:18'!
project

	^self new project! !

!ConfigurationOfPeriscope class methodsFor: 'development support' stamp: 'TorstenBergmann 11/14/2013 21:18'!
validate
	"Check the configuration for Errors, Critical Warnings, and Warnings (see class comment for MetacelloMCVersionValidator for more information). 
	Errors identify specification issues that will result in unexpected behaviour when you load the configuration. 
	Critical Warnings identify specification issues that may result in unexpected behavior when you load the configuration.
	Warnings identify specification issues that are technically correct, but are worth take a look at."

	"self validate"

	<apiDocumentation>
	self ensureMetacello.
	^ ((Smalltalk at: #MetacelloToolBox) validateConfiguration: self debug: #() recurse: false) explore! !

!ConfigurationOfPeriscope methodsFor: 'baselines' stamp: 'TorstenBergmann 11/14/2013 21:20'!
baseline10: spec 
        <version: '1.0-baseline'>
        
        spec for: #common do: [
                spec blessing: #baseline.
                spec repository: 'http://smalltalkhub.com/mc/PavelKrivanek/Periscope/main/'.    
		    spec package: 'Periscope'.
        ].! !

!ConfigurationOfPeriscope methodsFor: 'accessing' stamp: 'TorstenBergmann 11/14/2013 21:18'!
customProjectAttributes
	 "Edit to return a collection of any custom attributes e.g. for conditional loading: Array with: #'Condition1' with: #'Condition2.
	For more information see: http://code.google.com/p/metacello/wiki/CustomProjectAttrributes"

	^ #().! !

!ConfigurationOfPeriscope methodsFor: 'symbolic versions' stamp: 'TorstenBergmann 11/14/2013 21:22'!
development: spec
	<symbolicVersion: #'development'>

	spec for: #'common' version: '1.0'.
! !

!ConfigurationOfPeriscope methodsFor: 'doits' stamp: 'TorstenBergmann 11/14/2013 21:21'!
postloadForCore: loader package: packageSpec
	 
	Nautilus pluginClasses add: {(Smalltalk at: #NautilusPeriscopePlugin). #none}! !

!ConfigurationOfPeriscope methodsFor: 'accessing' stamp: 'TorstenBergmann 11/14/2013 21:18'!
project

	^ project ifNil: [ | constructor |
		"Bootstrap Metacello if it is not already loaded"
		(self class baseConfigurationClassIfAbsent: []) ensureMetacello.
		"Construct Metacello project"
		project := MetacelloMCProject new projectAttributes: self customProjectAttributes. 
		constructor := (Smalltalk at: #MetacelloVersionConstructor) on: self project: project.
		project loadType: #linear. "change to #atomic if desired"
		project ]! !

!ConfigurationOfPeriscope methodsFor: 'symbolic versions' stamp: 'TorstenBergmann 11/14/2013 21:22'!
stable: spec
	<symbolicVersion: #'stable'>

	spec for: #'common' version: '1.0'.
! !

!ConfigurationOfPeriscope methodsFor: 'versions' stamp: 'PavelKrivanek 11/14/2013 22:16'!
version10: spec 
        <version: '1.0' imports: #('1.0-baseline')>

        spec for: #common do: [
                	spec blessing: #development.
			spec description: 'Initial release'.
			spec author: 'PavelKrivanek'.
			spec timestamp: '11/14/2013 21:25'.	
			spec package: 'Periscope' with: 'Periscope-PavelKrivanek.37'.
			
			"postload"
			spec postLoadDoIt: #postloadForCore:package:  ].! !
